Index: vl.c
===================================================================
--- vl.c	(revision 4734)
+++ vl.c	(working copy)
@@ -29,6 +29,11 @@
 #include "hw/audiodev.h"
 #include "hw/isa.h"
 #include "hw/baum.h"
+#include "hw/pci.h"
+#include "hw/mcf.h"
+#include "hw/devices.h"
+#include "hw/arm-misc.h"
+#include "hw/mips.h"
 #include "net.h"
 #include "console.h"
 #include "sysemu.h"
@@ -170,27 +175,18 @@
 int vga_ram_size;
 static DisplayState display_state;
 int nographic;
-int curses;
 const char* keyboard_layout = NULL;
 int64_t ticks_per_sec;
 ram_addr_t ram_size;
 int pit_min_timer_count = 0;
-int nb_nics;
-NICInfo nd_table[MAX_NICS];
 int vm_running;
 static int rtc_utc = 1;
 static int rtc_date_offset = -1; /* -1 means no change */
 int cirrus_vga_enabled = 1;
 int vmsvga_enabled = 0;
-#ifdef TARGET_SPARC
-int graphic_width = 1024;
-int graphic_height = 768;
-int graphic_depth = 8;
-#else
-int graphic_width = 800;
-int graphic_height = 600;
-int graphic_depth = 15;
-#endif
+int graphic_width;
+int graphic_height;
+int graphic_depth;
 int full_screen = 0;
 int no_frame = 0;
 int no_quit = 0;
@@ -239,6 +235,8 @@
 static CPUState *cur_cpu;
 static CPUState *next_cpu;
 static int event_pending = 1;
+QEMUDevice *qemu_prefs;
+QEMUDevice *machine_dev;
 
 #define TFR(expr) do { if ((expr) != -1) break; } while (errno == EINTR)
 
@@ -3816,18 +3814,6 @@
     slirp_input(buf, size);
 }
 
-static int net_slirp_init(VLANState *vlan)
-{
-    if (!slirp_inited) {
-        slirp_inited = 1;
-        slirp_init();
-    }
-    slirp_vc = qemu_new_vlan_client(vlan,
-                                    slirp_receive, NULL, NULL);
-    snprintf(slirp_vc->info_str, sizeof(slirp_vc->info_str), "user redirector");
-    return 0;
-}
-
 static void net_slirp_redir(const char *redir_str)
 {
     int is_udp;
@@ -3971,6 +3957,58 @@
 }
 
 #endif /* !defined(_WIN32) */
+
+#define SLIRP_MAX_REDIRS 8
+
+static int net_slirp_init(QEMUDevice *dev)
+{
+    VLANState *vlan;
+    int vlan_id, i;
+    const char *str;
+    char buf[128];
+
+    vlan_id = qemu_device_get_int(dev, "vlan");
+    vlan = qemu_find_vlan(vlan_id);
+    if (!vlan) {
+        fprintf(stderr, "Could not create vlan %d\n", vlan_id);
+        return -1;
+    }
+    if (!slirp_inited) {
+        slirp_inited = 1;
+        slirp_init();
+    }
+    str = qemu_device_get_str(dev, "hostname");
+    if (str[0] != '\0') {
+        pstrcpy(slirp_hostname, sizeof(slirp_hostname), str);
+    }
+    str = qemu_device_get_str(dev, "tftp");
+    if (str[0] != '\0')
+        tftp_prefix = str;
+    str = qemu_device_get_str(dev, "bootp");
+    if (str[0] != '\0')
+        bootp_filename = str;
+#if !defined(_WIN32)
+    str = qemu_device_get_str(dev, "smb");
+    if (str[0] != '\0') {
+        net_slirp_smb(str);
+    }
+#endif
+    
+    for(i = 0; i < SLIRP_MAX_REDIRS; i++) {
+        snprintf(buf, sizeof(buf), "redir%d", i);
+        str = qemu_device_get_str(dev, buf);
+        if (str[0] == '\0') 
+            break;
+        net_slirp_redir(str);
+    }
+    
+    slirp_vc = qemu_new_vlan_client(vlan,
+                                    slirp_receive, NULL, NULL);
+    snprintf(slirp_vc->info_str, sizeof(slirp_vc->info_str), "user redirector");
+    vlan->nb_host_devs++;
+    return 0;
+}
+
 void do_info_slirp(void)
 {
     slirp_stats();
@@ -4286,8 +4324,61 @@
     return 0;
 }
 
+static int net_tap_init2(QEMUDevice *dev)
+{
+    VLANState *vlan;
+    int vlan_id;
+    const char *ifname, *setup_script, *down_script;
+    int fd;
+
+    vlan_id = qemu_device_get_int(dev, "vlan");
+    vlan = qemu_find_vlan(vlan_id);
+    if (!vlan) {
+        fprintf(stderr, "Could not create vlan %d\n", vlan_id);
+        return -1;
+    }
+    vlan->nb_host_devs++;
+
+    fd = qemu_device_get_int(dev, "fd");
+    if (fd >= 0) {
+        fcntl(fd, F_SETFL, O_NONBLOCK);
+        if (net_tap_fd_init(vlan, fd))
+            return 0;
+        else
+            return -1;
+    } else {
+        ifname = qemu_device_get_str(dev, "ifname");
+        setup_script = qemu_device_get_str(dev, "script");
+        if (setup_script[0] == '\0')
+            setup_script = DEFAULT_NETWORK_SCRIPT;
+        down_script = qemu_device_get_str(dev, "downscript");
+        if (down_script[0] == '\0')
+            down_script = DEFAULT_NETWORK_DOWN_SCRIPT;
+        return net_tap_init(vlan, ifname, setup_script, down_script);
+    }
+}
+
 #endif /* !_WIN32 */
 
+#ifdef _WIN32
+static int net_tap_init2(QEMUDevice *dev)
+{
+    VLANState *vlan;
+    int vlan_id;
+    const char *ifname;
+
+    vlan_id = qemu_device_get_int(dev, "vlan");
+    vlan = qemu_find_vlan(vlan_id);
+    if (!vlan) {
+        fprintf(stderr, "Could not create vlan %d\n", vlan_id);
+        return -1;
+    }
+    vlan->nb_host_devs++;
+    ifname = qemu_device_get_str(dev, "ifname");
+    return tap_win32_init(vlan, ifname);
+}
+#endif
+
 /* network connection */
 typedef struct NetSocketState {
     VLANClientState *vc;
@@ -4701,8 +4792,43 @@
 
 }
 
-static const char *get_opt_name(char *buf, int buf_size, const char *p)
+int net_socket_init(QEMUDevice *dev)
 {
+    VLANState *vlan;
+    int vlan_id, fd, ret;
+    const char *listen_str, *connect_str, *mcast_str;
+    vlan_id = qemu_device_get_int(dev, "vlan");
+    vlan = qemu_find_vlan(vlan_id);
+    if (!vlan) {
+        fprintf(stderr, "Could not create vlan %d\n", vlan_id);
+        return -1;
+    }
+    fd = qemu_device_get_int(dev, "fd");
+    listen_str = qemu_device_get_str(dev, "listen");
+    connect_str = qemu_device_get_str(dev, "connect");
+    mcast_str = qemu_device_get_str(dev, "mcast");
+    ret = -1;
+
+    if (fd >= 0) {
+        if (net_socket_fd_init(vlan, fd, 1))
+            ret = 0;
+    } else if (listen_str[0] != '\0') {
+        ret = net_socket_listen_init(vlan, listen_str);
+    } else if (connect_str[0] != '\0') {
+        ret = net_socket_connect_init(vlan, connect_str);
+    } else if (mcast_str[0] != '\0') {
+        ret = net_socket_mcast_init(vlan, mcast_str);
+    } else {
+        fprintf(stderr, "%s: no socket connection specified\n", dev->name);
+        return -1;
+    }
+    if (ret == 0)
+        vlan->nb_host_devs++;
+    return ret;
+}
+
+const char *get_opt_name(char *buf, int buf_size, const char *p)
+{
     char *q;
 
     q = buf;
@@ -4717,7 +4843,7 @@
     return p;
 }
 
-static const char *get_opt_value(char *buf, int buf_size, const char *p)
+const char *get_opt_value(char *buf, int buf_size, const char *p)
 {
     char *q;
 
@@ -4738,8 +4864,8 @@
     return p;
 }
 
-static int get_param_value(char *buf, int buf_size,
-                           const char *tag, const char *str)
+int get_param_value(char *buf, int buf_size,
+                    const char *tag, const char *str)
 {
     const char *p;
     char option[128];
@@ -4763,40 +4889,16 @@
     return 0;
 }
 
-static int check_params(char *buf, int buf_size,
-                        char **params, const char *str)
-{
-    const char *p;
-    int i;
+static QEMUMachine *find_machine(const char *name);
 
-    p = str;
-    for(;;) {
-        p = get_opt_name(buf, buf_size, p);
-        if (*p != '=')
-            return -1;
-        p++;
-        for(i = 0; params[i] != NULL; i++)
-            if (!strcmp(params[i], buf))
-                break;
-        if (params[i] == NULL)
-            return -1;
-        p = get_opt_value(NULL, 0, p);
-        if (*p != ',')
-            break;
-        p++;
-    }
-    return 0;
-}
-
-
-static int net_client_init(const char *str)
+static int net_add(const char *str)
 {
     const char *p;
     char *q;
     char device[64];
     char buf[1024];
-    int vlan_id, ret;
-    VLANState *vlan;
+    QEMUDevice *dev;
+    QEMUDeviceClass *dc;
 
     p = str;
     q = device;
@@ -4808,124 +4910,50 @@
     *q = '\0';
     if (*p == ',')
         p++;
-    vlan_id = 0;
-    if (get_param_value(buf, sizeof(buf), "vlan", p)) {
-        vlan_id = strtol(buf, NULL, 0);
-    }
-    vlan = qemu_find_vlan(vlan_id);
-    if (!vlan) {
-        fprintf(stderr, "Could not create vlan %d\n", vlan_id);
-        return -1;
-    }
     if (!strcmp(device, "nic")) {
-        NICInfo *nd;
-        uint8_t *macaddr;
-
-        if (nb_nics >= MAX_NICS) {
-            fprintf(stderr, "Too Many NICs\n");
-            return -1;
-        }
-        nd = &nd_table[nb_nics];
-        macaddr = nd->macaddr;
-        macaddr[0] = 0x52;
-        macaddr[1] = 0x54;
-        macaddr[2] = 0x00;
-        macaddr[3] = 0x12;
-        macaddr[4] = 0x34;
-        macaddr[5] = 0x56 + nb_nics;
-
-        if (get_param_value(buf, sizeof(buf), "macaddr", p)) {
-            if (parse_macaddr(macaddr, buf) < 0) {
-                fprintf(stderr, "invalid syntax for ethernet address\n");
+        if (get_param_value(buf, sizeof(buf), "model", p) <= 0) {
+            /* no network card, get a default */
+            QEMUMachine *machine;
+            machine = find_machine(machine_dev->dev_class->name);
+            if (machine->default_nic_model) {
+                pstrcpy(buf, sizeof(buf), machine->default_nic_model);
+            } else {
+                fprintf(stderr, "You must specify the NIC model\n");
                 return -1;
             }
         }
-        if (get_param_value(buf, sizeof(buf), "model", p)) {
-            nd->model = strdup(buf);
+        dc = qemu_class_find(buf);
+        if (!dc) {
+            fprintf(stderr, "unknown network device '%s'\n", buf);
+            return -1;
         }
-        nd->vlan = vlan;
-        nb_nics++;
-        vlan->nb_guest_devs++;
-        ret = 0;
+        dev = qemu_device_new_nodup(dc, "nic");
+        if (qemu_device_set_params(dev, p, "model=!") < 0) {
+            fprintf(stderr, "Invalid network device options '%s'\n", p);
+            return -1;
+        }
     } else
     if (!strcmp(device, "none")) {
         /* does nothing. It is needed to signal that no network cards
            are wanted */
-        ret = 0;
-    } else
-#ifdef CONFIG_SLIRP
-    if (!strcmp(device, "user")) {
-        if (get_param_value(buf, sizeof(buf), "hostname", p)) {
-            pstrcpy(slirp_hostname, sizeof(slirp_hostname), buf);
-        }
-        vlan->nb_host_devs++;
-        ret = net_slirp_init(vlan);
-    } else
-#endif
-#ifdef _WIN32
-    if (!strcmp(device, "tap")) {
-        char ifname[64];
-        if (get_param_value(ifname, sizeof(ifname), "ifname", p) <= 0) {
-            fprintf(stderr, "tap: no interface name\n");
+    } else {
+        if (!strcmp(device, "user")) {
+            dc = qemu_class_find("net-user");
+        } else if (!strcmp(device, "tap")) {
+            dc = qemu_class_find("net-tap");
+        } else if (!strcmp(device, "socket")) {
+            dc = qemu_class_find("net-socket");
+        } else {
+            fprintf(stderr, "Unknown network device: %s\n", device);
             return -1;
         }
-        vlan->nb_host_devs++;
-        ret = tap_win32_init(vlan, ifname);
-    } else
-#else
-    if (!strcmp(device, "tap")) {
-        char ifname[64];
-        char setup_script[1024], down_script[1024];
-        int fd;
-        vlan->nb_host_devs++;
-        if (get_param_value(buf, sizeof(buf), "fd", p) > 0) {
-            fd = strtol(buf, NULL, 0);
-            fcntl(fd, F_SETFL, O_NONBLOCK);
-            ret = -1;
-            if (net_tap_fd_init(vlan, fd))
-                ret = 0;
-        } else {
-            if (get_param_value(ifname, sizeof(ifname), "ifname", p) <= 0) {
-                ifname[0] = '\0';
-            }
-            if (get_param_value(setup_script, sizeof(setup_script), "script", p) == 0) {
-                pstrcpy(setup_script, sizeof(setup_script), DEFAULT_NETWORK_SCRIPT);
-            }
-            if (get_param_value(down_script, sizeof(down_script), "downscript", p) == 0) {
-                pstrcpy(down_script, sizeof(down_script), DEFAULT_NETWORK_DOWN_SCRIPT);
-            }
-            ret = net_tap_init(vlan, ifname, setup_script, down_script);
-        }
-    } else
-#endif
-    if (!strcmp(device, "socket")) {
-        if (get_param_value(buf, sizeof(buf), "fd", p) > 0) {
-            int fd;
-            fd = strtol(buf, NULL, 0);
-            ret = -1;
-            if (net_socket_fd_init(vlan, fd, 1))
-                ret = 0;
-        } else if (get_param_value(buf, sizeof(buf), "listen", p) > 0) {
-            ret = net_socket_listen_init(vlan, buf);
-        } else if (get_param_value(buf, sizeof(buf), "connect", p) > 0) {
-            ret = net_socket_connect_init(vlan, buf);
-        } else if (get_param_value(buf, sizeof(buf), "mcast", p) > 0) {
-            ret = net_socket_mcast_init(vlan, buf);
-        } else {
-            fprintf(stderr, "Unknown socket options: %s\n", p);
+        dev = qemu_device_new_nodup(dc, "net");
+        if (qemu_device_set_params(dev, p, "") < 0) {
+            fprintf(stderr, "Invalid network device options\n");
             return -1;
         }
-        vlan->nb_host_devs++;
-    } else
-    {
-        fprintf(stderr, "Unknown network device: %s\n", device);
-        return -1;
     }
-    if (ret < 0) {
-        fprintf(stderr, "Could not initialize device '%s'\n", device);
-    }
-
-    return ret;
+    return 0;
 }
 
 void do_info_network(void)
@@ -4951,21 +4979,112 @@
 #define MTD_ALIAS "if=mtd"
 #define SD_ALIAS "index=0,if=sd"
 
+
+static int drive_get_type(BlockInterfaceType *ptype,
+                          int *pmax_devs, 
+                          const char *str)
+{
+    BlockInterfaceType type;
+    int max_devs;
+
+    if (!strcmp(str, "ide")) {
+        type = IF_IDE;
+        max_devs = MAX_IDE_DEVS;
+    } else if (!strcmp(str, "scsi")) {
+        type = IF_SCSI;
+        max_devs = MAX_SCSI_DEVS;
+    } else if (!strcmp(str, "floppy")) {
+        type = IF_FLOPPY;
+        max_devs = 0;
+    } else if (!strcmp(str, "pflash")) {
+        type = IF_PFLASH;
+        max_devs = 0;
+    } else if (!strcmp(str, "mtd")) {
+        type = IF_MTD;
+        max_devs = 0;
+    } else if (!strcmp(str, "sd")) {
+        type = IF_SD;
+        max_devs = 0;
+    } else {
+        return -1;
+    }
+    if (ptype)
+        *ptype = type;
+    if (pmax_devs)
+        *pmax_devs = max_devs;
+    return 0;
+}
+
 static int drive_add(const char *file, const char *fmt, ...)
 {
     va_list ap;
+    BlockInterfaceType type;
+    int max_devs;
+    char buf[1024], opt_value[1024];
+    QEMUDeviceClass *dc;
+    QEMUDevice *dev;
 
-    if (nb_drives_opt >= MAX_DRIVES) {
-        fprintf(stderr, "qemu: too many drives\n");
-        exit(1);
-    }
-
-    drives_opt[nb_drives_opt].file = file;
     va_start(ap, fmt);
-    vsnprintf(drives_opt[nb_drives_opt].opt,
-              sizeof(drives_opt[0].opt), fmt, ap);
+    vsnprintf(buf, sizeof(buf), fmt, ap);
     va_end(ap);
+    
+    /* find type */
+    if (get_param_value(opt_value, sizeof(opt_value), "if", buf) <= 0) {
+        const char *name;
+        name = machine_dev->dev_class->name;
+        if (!strcmp(name, "realview") ||
+            !strcmp(name, "SS-5") ||
+            !strcmp(name, "SS-10") ||
+            !strcmp(name, "SS-600MP") ||
+            !strcmp(name, "versatilepb") ||
+            !strcmp(name, "versatileab")) {
+            pstrcpy(opt_value, sizeof(opt_value), "scsi");
+        } else {
+            pstrcpy(opt_value, sizeof(opt_value), "ide");
+        }
+    }
+    
+    if (drive_get_type(&type, &max_devs, opt_value) < 0) {
+        fprintf(stderr, "Invalid drive type '%s'\n", opt_value);
+        return -1;
+    }
 
+    dc = qemu_class_find(opt_value);
+    if (!dc) 
+        return -1;
+
+#if 0
+    {
+        const char *mediastr;
+        /* XXX: could compute a better default device name */
+        if (type == IF_IDE || type == IF_SCSI) {
+            mediastr = qemu_device_get_str(dev, "media");
+            if (!strcmp("cdrom"))
+                mediastr = "_cd";
+            else
+                mediastr = "_hd";
+        } else {
+            mediastr = "";
+        }
+        if (max_devs)
+            snprintf(dev_name, sizeof(dev_name), "%s%i%s%i",
+                     dc->name, bus_id, mediastr, unit_id);
+        else
+            snprintf(dev_name, sizeof(dev_name), "%s%s%i",
+                     dc->name, mediastr, unit_id);
+    }
+#endif
+    dev = qemu_device_new_nodup(dc, "drive");
+
+    if (qemu_device_set_params(dev, buf, "if=!") < 0) {
+        fprintf(stderr, "Invalid drive options\n");
+        return -1;
+    }
+
+    if (file) {
+        qemu_device_set_str(dev, "file", file);
+    }
+
     return nb_drives_opt++;
 }
 
@@ -5003,13 +5122,8 @@
     fprintf(stderr, " %s", name);
 }
 
-static int drive_init(struct drive_opt *arg, int snapshot,
-                      QEMUMachine *machine)
+static int drive_init(QEMUDevice *dev)
 {
-    char buf[128];
-    char file[1024];
-    char devname[128];
-    const char *mediastr = "";
     BlockInterfaceType type;
     enum { MEDIA_DISK, MEDIA_CDROM } media;
     int bus_id, unit_id;
@@ -5020,202 +5134,118 @@
     int index;
     int cache;
     int bdrv_flags;
-    char *str = arg->opt;
-    char *params[] = { "bus", "unit", "if", "index", "cyls", "heads",
-                       "secs", "trans", "media", "snapshot", "file",
-                       "cache", "format", NULL };
+    const char *str, *file;
+    int snapshot;
 
-    if (check_params(buf, sizeof(buf), params, str) < 0) {
-         fprintf(stderr, "qemu: unknown parameter '%s' in '%s'\n",
-                         buf, str);
-         return -1;
-    }
-
-    file[0] = 0;
-    cyls = heads = secs = 0;
-    bus_id = 0;
-    unit_id = -1;
-    translation = BIOS_ATA_TRANSLATION_AUTO;
-    index = -1;
-    cache = 1;
-
-    if (!strcmp(machine->name, "realview") ||
-        !strcmp(machine->name, "SS-5") ||
-        !strcmp(machine->name, "SS-10") ||
-        !strcmp(machine->name, "SS-600MP") ||
-        !strcmp(machine->name, "versatilepb") ||
-        !strcmp(machine->name, "versatileab")) {
-        type = IF_SCSI;
-        max_devs = MAX_SCSI_DEVS;
-        strcpy(devname, "scsi");
-    } else {
-        type = IF_IDE;
-        max_devs = MAX_IDE_DEVS;
-        strcpy(devname, "ide");
-    }
-    media = MEDIA_DISK;
-
     /* extract parameters */
 
-    if (get_param_value(buf, sizeof(buf), "bus", str)) {
-        bus_id = strtol(buf, NULL, 0);
-	if (bus_id < 0) {
-	    fprintf(stderr, "qemu: '%s' invalid bus id\n", str);
-	    return -1;
-	}
-    }
+    if (drive_get_type(&type, &max_devs, dev->dev_class->name) < 0)
+        return -1;
 
-    if (get_param_value(buf, sizeof(buf), "unit", str)) {
-        unit_id = strtol(buf, NULL, 0);
-	if (unit_id < 0) {
-	    fprintf(stderr, "qemu: '%s' invalid unit id\n", str);
-	    return -1;
-	}
-    }
+    bus_id = qemu_device_get_int(dev, "bus");
+    if (bus_id < 0)
+        return -1;
 
-    if (get_param_value(buf, sizeof(buf), "if", str)) {
-        pstrcpy(devname, sizeof(devname), buf);
-        if (!strcmp(buf, "ide")) {
-	    type = IF_IDE;
-            max_devs = MAX_IDE_DEVS;
-        } else if (!strcmp(buf, "scsi")) {
-	    type = IF_SCSI;
-            max_devs = MAX_SCSI_DEVS;
-        } else if (!strcmp(buf, "floppy")) {
-	    type = IF_FLOPPY;
-            max_devs = 0;
-        } else if (!strcmp(buf, "pflash")) {
-	    type = IF_PFLASH;
-            max_devs = 0;
-	} else if (!strcmp(buf, "mtd")) {
-	    type = IF_MTD;
-            max_devs = 0;
-	} else if (!strcmp(buf, "sd")) {
-	    type = IF_SD;
-            max_devs = 0;
-	} else {
-            fprintf(stderr, "qemu: '%s' unsupported bus type '%s'\n", str, buf);
-            return -1;
-	}
-    }
+    unit_id = qemu_device_get_int(dev, "unit");
+    if (unit_id < 0 && unit_id != -1)
+        return -1;
 
-    if (get_param_value(buf, sizeof(buf), "index", str)) {
-        index = strtol(buf, NULL, 0);
-	if (index < 0) {
-	    fprintf(stderr, "qemu: '%s' invalid index\n", str);
-	    return -1;
-	}
+    index = qemu_device_get_int(dev, "index");
+    if (index < 0 && index != -1)
+        return -1;
+    
+    cyls = heads = secs = 0;
+    translation = BIOS_ATA_TRANSLATION_AUTO;
+    if (type == IF_IDE || type == IF_SCSI) {
+        cyls = qemu_device_get_int(dev, "cyls");
+        heads = qemu_device_get_int(dev, "heads");
+        secs = qemu_device_get_int(dev, "secs");
+        
+        if (cyls || heads || secs) {
+            if (cyls < 1 || cyls > 16383) {
+                fprintf(stderr, "qemu: '%d' invalid physical cyls number\n", cyls);
+                return -1;
+            }
+            if (heads < 1 || heads > 16) {
+                fprintf(stderr, "qemu: '%d' invalid physical heads number\n", heads);
+                return -1;
+            }
+            if (secs < 1 || secs > 63) {
+                fprintf(stderr, "qemu: '%d' invalid physical secs number\n", secs);
+                return -1;
+            }
+        }
+        
+        str = qemu_device_get_str(dev, "trans");
+        if (str[0] != '\0') {
+            if (!cyls) {
+                fprintf(stderr,
+                        "qemu: '%s' trans must be used with cyls,heads and secs\n",
+                        str);
+                return -1;
+            }
+            if (!strcmp(str, "none"))
+                translation = BIOS_ATA_TRANSLATION_NONE;
+            else if (!strcmp(str, "lba"))
+                translation = BIOS_ATA_TRANSLATION_LBA;
+            else if (!strcmp(str, "auto"))
+                translation = BIOS_ATA_TRANSLATION_AUTO;
+            else {
+                fprintf(stderr, "qemu: '%s' invalid translation type\n", str);
+                return -1;
+            }
+        }
     }
 
-    if (get_param_value(buf, sizeof(buf), "cyls", str)) {
-        cyls = strtol(buf, NULL, 0);
-    }
 
-    if (get_param_value(buf, sizeof(buf), "heads", str)) {
-        heads = strtol(buf, NULL, 0);
-    }
-
-    if (get_param_value(buf, sizeof(buf), "secs", str)) {
-        secs = strtol(buf, NULL, 0);
-    }
-
-    if (cyls || heads || secs) {
-        if (cyls < 1 || cyls > 16383) {
-            fprintf(stderr, "qemu: '%s' invalid physical cyls number\n", str);
-	    return -1;
-	}
-        if (heads < 1 || heads > 16) {
-            fprintf(stderr, "qemu: '%s' invalid physical heads number\n", str);
-	    return -1;
-	}
-        if (secs < 1 || secs > 63) {
-            fprintf(stderr, "qemu: '%s' invalid physical secs number\n", str);
-	    return -1;
-	}
-    }
-
-    if (get_param_value(buf, sizeof(buf), "trans", str)) {
-        if (!cyls) {
-            fprintf(stderr,
-                    "qemu: '%s' trans must be used with cyls,heads and secs\n",
-                    str);
-            return -1;
-        }
-        if (!strcmp(buf, "none"))
-            translation = BIOS_ATA_TRANSLATION_NONE;
-        else if (!strcmp(buf, "lba"))
-            translation = BIOS_ATA_TRANSLATION_LBA;
-        else if (!strcmp(buf, "auto"))
-            translation = BIOS_ATA_TRANSLATION_AUTO;
-	else {
-            fprintf(stderr, "qemu: '%s' invalid translation type\n", str);
-	    return -1;
-	}
-    }
-
-    if (get_param_value(buf, sizeof(buf), "media", str)) {
-        if (!strcmp(buf, "disk")) {
-	    media = MEDIA_DISK;
-	} else if (!strcmp(buf, "cdrom")) {
+    str = qemu_device_get_str(dev, "media");
+    if (str[0] != '\0') {
+        if (!strcmp(str, "disk")) {
+            media = MEDIA_DISK;
+        } else if (!strcmp(str, "cdrom")) {
             if (cyls || secs || heads) {
                 fprintf(stderr,
                         "qemu: '%s' invalid physical CHS format\n", str);
-	        return -1;
+                return -1;
             }
-	    media = MEDIA_CDROM;
-	} else {
-	    fprintf(stderr, "qemu: '%s' invalid media\n", str);
-	    return -1;
-	}
+            media = MEDIA_CDROM;
+        } else {
+            fprintf(stderr, "qemu: '%s' invalid media\n", str);
+            return -1;
+        }
+    } else {
+        media = MEDIA_DISK;
     }
 
-    if (get_param_value(buf, sizeof(buf), "snapshot", str)) {
-        if (!strcmp(buf, "on"))
-	    snapshot = 1;
-        else if (!strcmp(buf, "off"))
-	    snapshot = 0;
-	else {
-	    fprintf(stderr, "qemu: '%s' invalid snapshot option\n", str);
-	    return -1;
-	}
-    }
+    snapshot = qemu_device_get_bool(dev, "snapshot") ||
+        qemu_device_get_bool(machine_dev, "snapshot");
 
-    if (get_param_value(buf, sizeof(buf), "cache", str)) {
-        if (!strcmp(buf, "off"))
-            cache = 0;
-        else if (!strcmp(buf, "on"))
-            cache = 1;
-        else {
-           fprintf(stderr, "qemu: invalid cache option\n");
-           return -1;
-        }
-    }
+    cache = qemu_device_get_bool(dev, "cache");
 
-    if (get_param_value(buf, sizeof(buf), "format", str)) {
-       if (strcmp(buf, "?") == 0) {
+    str = qemu_device_get_str(dev, "format");
+    if (str[0] != '\0') {
+        if (strcmp(str, "?") == 0) {
             fprintf(stderr, "qemu: Supported formats:");
             bdrv_iterate_format(bdrv_format_print, NULL);
             fprintf(stderr, "\n");
 	    return -1;
         }
-        drv = bdrv_find_format(buf);
+        drv = bdrv_find_format(str);
         if (!drv) {
-            fprintf(stderr, "qemu: '%s' invalid format\n", buf);
+            fprintf(stderr, "qemu: '%s' invalid format\n", str);
             return -1;
         }
     }
 
-    if (arg->file == NULL)
-        get_param_value(file, sizeof(file), "file", str);
-    else
-        pstrcpy(file, sizeof(file), arg->file);
+    file = qemu_device_get_str(dev, "file");
 
     /* compute bus and unit according index */
 
     if (index != -1) {
         if (bus_id != 0 || unit_id != -1) {
             fprintf(stderr,
-                    "qemu: '%s' index cannot be used with bus and unit\n", str);
+                    "qemu: '%d' index cannot be used with bus and unit\n", 
+                    index);
             return -1;
         }
         if (max_devs == 0)
@@ -5259,16 +5289,7 @@
         return 0;
 
     /* init */
-
-    if (type == IF_IDE || type == IF_SCSI)
-        mediastr = (media == MEDIA_CDROM) ? "-cd" : "-hd";
-    if (max_devs)
-        snprintf(buf, sizeof(buf), "%s%i%s%i",
-                 devname, bus_id, mediastr, unit_id);
-    else
-        snprintf(buf, sizeof(buf), "%s%s%i",
-                 devname, mediastr, unit_id);
-    bdrv = bdrv_new(buf);
+    bdrv = bdrv_new(dev->name);
     drives_table[nb_drives].bdrv = bdrv;
     drives_table[nb_drives].type = type;
     drives_table[nb_drives].bus = bus_id;
@@ -5332,11 +5353,38 @@
     free_usb_ports = port;
 }
 
+static int usb_device_add_dev(USBDevice *dev)
+{
+    USBPort *port;
+
+    /* Find a USB port to add the device to.  */
+    port = free_usb_ports;
+    if (!port)
+        return -1;
+    if (!port->next) {
+        USBDevice *hub;
+
+        /* Create a new hub and chain it on.  */
+        free_usb_ports = NULL;
+        port->next = used_usb_ports;
+        used_usb_ports = port;
+
+        hub = usb_hub_init(VM_USB_HUB_SIZE);
+        usb_attach(port, hub);
+        port = free_usb_ports;
+    }
+
+    free_usb_ports = port->next;
+    port->next = used_usb_ports;
+    used_usb_ports = port;
+    usb_attach(port, dev);
+    return 0;
+}
+
 static int usb_device_add(const char *devname)
 {
     const char *p;
     USBDevice *dev;
-    USBPort *port;
 
     if (!free_usb_ports)
         return -1;
@@ -5364,29 +5412,70 @@
     }
     if (!dev)
         return -1;
+    return usb_device_add_dev(dev);
+}
 
-    /* Find a USB port to add the device to.  */
-    port = free_usb_ports;
-    if (!port->next) {
-        USBDevice *hub;
+static void usb_device_add_cmdline(const char *devname)
+{
+    QEMUDevice *dev;
+    const char *p;
 
-        /* Create a new hub and chain it on.  */
-        free_usb_ports = NULL;
-        port->next = used_usb_ports;
-        used_usb_ports = port;
+    if (strstart(devname, "host:", &p)) {
+        dev = qemu_device_new_nodup(qemu_class_find("usb-host"), "usb");
+        qemu_device_set_str(dev, "host_device", p);
+    } else if (!strcmp(devname, "mouse")) {
+        dev = qemu_device_new_nodup(qemu_class_find("usb-mouse"), "usb");
+    } else if (!strcmp(devname, "tablet")) {
+        dev = qemu_device_new_nodup(qemu_class_find("usb-tablet"), "usb");
+    } else if (!strcmp(devname, "keyboard")) {
+        dev = qemu_device_new_nodup(qemu_class_find("usb-keyboard"), "usb");
+    } else if (strstart(devname, "disk:", &p)) {
+        dev = qemu_device_new_nodup(qemu_class_find("usb-msd"), "usb");
+        qemu_device_set_str(dev, "file", p);
+    } else if (!strcmp(devname, "wacom-tablet")) {
+        dev = qemu_device_new_nodup(qemu_class_find("usb-wacom-tablet"), "usb");
+    } else if (strstart(devname, "serial:", &p)) {
+        dev = qemu_device_new_nodup(qemu_class_find("usb-serial"), "usb");
+        qemu_device_set_str(dev, "device", p);
+#ifdef CONFIG_BRLAPI
+    } else if (!strcmp(devname, "braille")) {
+        dev = qemu_device_new_nodup(qemu_class_find("usb-braille"), "usb");
+#endif
+    } else {
+        fprintf(stderr, "Warning: could not add USB device %s\n",
+                devname);
+    }
+}
 
-        hub = usb_hub_init(VM_USB_HUB_SIZE);
-        usb_attach(port, hub);
-        port = free_usb_ports;
+/* XXX: should be handled in each device */
+static int usb_device_init(QEMUDevice *dev)
+{
+    USBDevice *(*usb_dev_init)(void);
+    const char *str;
+    USBDevice *usb_dev;
+
+    if (!free_usb_ports)
+        return -1;
+
+    if (!strcmp(dev->dev_class->name, "usb-host")) {
+        str = qemu_device_get_str(dev, "host_device");
+        usb_dev = usb_host_device_open(str);
+    } else if (!strcmp(dev->dev_class->name, "usb-msd")) {
+        str = qemu_device_get_str(dev, "file");
+        usb_dev = usb_msd_init(str);
+    } else if (!strcmp(dev->dev_class->name, "usb-serial")) {
+        str = qemu_device_get_str(dev, "device");
+        usb_dev = usb_serial_init(str);
+    } else {
+        usb_dev_init = dev->dev_class->opaque;
+        usb_dev = usb_dev_init();
     }
-
-    free_usb_ports = port->next;
-    port->next = used_usb_ports;
-    used_usb_ports = port;
-    usb_attach(port, dev);
-    return 0;
+    if (!usb_dev)
+        return -1;
+    return usb_device_add_dev(usb_dev);
 }
 
+
 static int usb_device_del(const char *devname)
 {
     USBPort *port;
@@ -5850,6 +5939,41 @@
     return size1 - size;
 }
 
+/* Same as qemu_get_byte but return EOF (-1) at end of file */
+int qemu_getc(QEMUFile *f)
+{
+    if (f->buf_index >= f->buf_size) {
+        qemu_fill_buffer(f);
+        if (f->buf_index >= f->buf_size)
+            return -1;
+    }
+    return f->buf[f->buf_index++];
+}
+
+/* Return EOF (-1) if end of file reached */
+int qemu_get_line(QEMUFile *f, char *buf, int buf_size)
+{
+    char *q;
+    int c;
+    q = buf;
+    for(;;) {
+        c = qemu_getc(f);
+        if (c == '\n') {
+            break;
+        } else if (c == EOF) {
+            if (q == buf)
+                return EOF;
+            else
+                break;
+        } else {
+            if ((q - buf) < (buf_size - 1))
+                *q++ = c;
+        }
+    }
+    *q = '\0';
+    return 0;
+}
+
 int qemu_get_byte(QEMUFile *f)
 {
     if (f->buf_index >= f->buf_size) {
@@ -7378,6 +7502,9 @@
     QEMU_OPTION_clock,
     QEMU_OPTION_startdate,
     QEMU_OPTION_tb_size,
+    QEMU_OPTION_f,
+    QEMU_OPTION_md,
+    QEMU_OPTION_dump_devices,
 };
 
 typedef struct QEMUOption {
@@ -7490,6 +7617,9 @@
     { "clock", HAS_ARG, QEMU_OPTION_clock },
     { "startdate", HAS_ARG, QEMU_OPTION_startdate },
     { "tb-size", HAS_ARG, QEMU_OPTION_tb_size },
+    { "f", HAS_ARG, QEMU_OPTION_f },
+    { "md", HAS_ARG, QEMU_OPTION_md },
+    { "dump-devices", 0, QEMU_OPTION_dump_devices },
     { NULL },
 };
 
